/* +++++[  MP2 - mp2fns.C ]+++++++++++++++++++++++++++++++++++++++++
   +                                                               +
   +  Name:   Mariusz Zaczek                                       +
   +  Class:  Tu 11-1                                              +
   +  Date:   2-10-1999                                            +
   +                                                               +
   + This file contains actual code of the functions declared in   +
   +    mp2fns.h                                                   +
   +                                                               +
   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */   
#include "array.h"
#include "string.h"
#include "named.h"



/* +++++[  RetrieveFromArray() ]++++++++++++++++++++++++++++++++++++
   +                                                               +
   + - parameters : Name - a string object                         +
   +                someArray - an array of type NamedItem of Etype+
   +                object - an Etype generic object.              +
   +                                                               +
   + - This ia a template function using Etype objects             +
   + - This function loops through _someArray_ to find if anyone   +
   +    array index has a last name equal to _Name_                +
   +     if YES -> return 1                                        +   
   +         NO -> return 0                                        +
   +                                                               +
   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
template<class Etype>
int RetrieveFromArray(String Name,Array< NamedItem <Etype> > &someArray,
                 Etype &object)
{
   for(int i=1;i <= someArray.Size() ; i++)
    if (Name == (someArray[i].GetLastName()))
    {
      object = (someArray[i].GetItem());

      return 1;
    }
return 0;
}


/* +++++[  ReturnFullName() ]+++++++++++++++++++++++++++++++++++++++
   +                                                               +
   + - parameters : Item - an class object of NamedItem of Etype   +
   +                                                               +
   + - This is a template function using Etype objects.            +
   + - The functions concates the inputted object's First Name     +
   +   and Last Name with a blank space between.                   +
   +                                                               +
   +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */  
template<class Etype>
String ReturnFullName(NamedItem<Etype> Item)
{
  return Item.GetFirstName() + " " + Item.GetLastName();
}

